import React from 'react';
import { DragSource } from 'react-dnd';

import style from './style.css';


var source = {
    beginDrag(props, monitor, component) {
        return {
            type: props.type,
            id: 0,
        };
    },
};

function collect(connect, monitor) {
    return {
        connectDragSource: connect.dragSource(),
    };
}

var ElementSourceItem = React.createClass({
    propTypes: {
        connectDragSource: React.PropTypes.func.isRequired,
        constant:          React.PropTypes.string,
        type:              React.PropTypes.string,
        name:              React.PropTypes.string,
        icon:              React.PropTypes.node,
        addElement:        React.PropTypes.func,
    },
    _clicked() {
        this.props.addElement(this.props.type);
    },
    render() {
        var { connectDragSource } = this.props;

        return connectDragSource(
            <div className={style.sourceItem} onClick={this._clicked}>
                {this.props.icon && (
                    <div className={style.icon}>{this.props.icon}</div>
                )}
                {this.props.name}
            </div>
        );
    },
});

export default DragSource(props => props.constant, source, collect)(ElementSourceItem);
