import React from 'react';
import classnames from 'classnames';

import style from '../../styles/common.css';


export default React.createClass({
    propTypes: {
        field:    React.PropTypes.object.isRequired,
        label:    React.PropTypes.node,
        comment:  React.PropTypes.node,
        children: React.PropTypes.node,
        showErrorsImmediately: React.PropTypes.bool,
        style:    React.PropTypes.object,
        size:     React.PropTypes.string,
    },
    getDefaultProps() {
        return {
            label: null,
            placeholder: '',
            showErrorsImmediately: true,
            style: {},

            // Options: 'sm', 'md', 'lg'
            size: 'sm',
        };
    },
    render() {
        let { field, comment, showErrorsImmediately, size } = this.props;
        let label = this.props.label ? <label className="control-label">{this.props.label}</label> : null;
        const sizeClass = 'form-group-' + size;

        const className = classnames([
            'form-group',
            sizeClass,
            { 'has-error': ((field.touched || showErrorsImmediately) && field.error) },
        ]);

        return (
            <div className={className} style={this.props.style}>
                {label}
                {comment && <div className={style.comment}>{comment}</div>}
                {this.props.children}
                {(field.touched || showErrorsImmediately) && field.error && <div className="help-block">{field.error}</div>}
            </div>
        );
    },
});
