import React, { PropTypes } from 'react';
import Editor from 'cccisd-wysiwyg';
import domOnlyProps from 'cccisd-redux-form-helpers/helpers/domOnlyProps.js';

import style from '../../styles/common.css';


export default React.createClass({
    propTypes: {
        field: PropTypes.object.isRequired,
        label: PropTypes.string,
        placeholder: PropTypes.string,
        comment: PropTypes.node,
        showErrorsImmediately: PropTypes.bool,
        isWysiwyg: PropTypes.bool,
        wysiwygProps: PropTypes.object,
        size: PropTypes.string,
        inputStyle: PropTypes.object,
    },
    getDefaultProps() {
        return {
            label: null,
            placeholder: '',
            showErrorsImmediately: true,
            isWysiwyg: false,
            wysiwygProps: {},

            // Options: 'sm', 'md', 'lg'
            size: 'sm',

            inputStyle: {},
        };
    },
    render() {
        var {
            field,
            comment,
            showErrorsImmediately,
            isWysiwyg,
            wysiwygProps,
            size,
            placeholder,
            inputStyle,
        } = this.props;
        var label = this.props.label ? <label className="control-label">{this.props.label}</label> : null;
        const sizeClass = 'form-group-' + size;

        return (
            <div className={'form-group ' + sizeClass + ' ' + ((field.touched || showErrorsImmediately) && field.error ? 'has-error' : '')}>
                {label}
                {comment && <div className={style.comment}>{comment}</div>}
                {!isWysiwyg ? (
                    <input
                        type="text"
                        placeholder={placeholder}
                        className="form-control"
                        style={inputStyle}
                        {...domOnlyProps(field)}
                    />
                ) : (
                    <Editor
                        {...wysiwygProps}
                        content={field.value.toString()}
                        type="input"
                        onChange={field.onChange}
                        style={inputStyle}
                    />
                )}
                {(field.touched || showErrorsImmediately) && field.error && <div className="help-block">{field.error}</div>}
            </div>
        );
    },
});
