import React, { PropTypes } from 'react';
import operators from '../operators.js';
import _find from 'lodash/find';
import FieldBlock from '../../../../components/FieldBlock';
import commonStyle from '../../../../styles/common.css';


export default React.createClass({
    propTypes: {
        dataConnector: PropTypes.object,
        field: PropTypes.object,
    },
    onChange(e) {
        const { dataConnector } = this.props;

        if (_find(operators[dataConnector.type], { code: e.target.value })) {
            this.props.field.onChange(e.target.value);
        } else {
            this.props.field.onChange(null);
        }
    },
    render() {
        const { dataConnector, field } = this.props;
        if (!dataConnector) {
            return null;
        }

        return (
            <div className={commonStyle.lastRow}>
                <FieldBlock field={field} label="">
                    <select
                        className="form-control"
                        style={{ width: 'auto' }}
                        onChange={this.onChange}
                        value={field.value}
                    >
                        <option key="no_value" value="0">- choose operator -</option>
                        {operators[dataConnector.type].map(operator => (
                            <option key={operator.code} value={operator.code}>{operator.title}</option>
                        ))}
                    </select>
                </FieldBlock>
            </div>
        );
    },
});
