import _isArray from 'lodash/isArray';
import _isObject from 'lodash/isObject';
import _forEach from 'lodash/forEach';

const checkForErrors = (field) => {
    if (field === undefined) {
        return false;
    }

    if (_isArray(field)) {
        for (var i; i < field.length; i++) {
            if (checkForErrors(field[i])) {
                return true;
            }
        }
    }

    if (!_isObject(field)) {
        console.warn('Field is not array or object');
        return false;
    }

    if (field.touched !== undefined) {
        return !!field.error;
    }

    var isError = false;
    _forEach(field, (item) => {
        if (!isError) {
            isError = checkForErrors(item);
        }
    });

    return isError;
};

export default checkForErrors;
