import _isString from 'lodash/isString';
import striptags from 'striptags';
import { decode } from 'he';


export default (args) => {
    args = _isString(args) ? { text: args } : args;
    var { text = '', length = 40, appendix = ' ...' } = args;

    text = decode(striptags(text).replace('&nbsp;', ' '));
    if (text.length <= length) {
        return text;
    }

    return text.substr(0, length - appendix.length) + appendix;
};
