/* global describe, it, expect */
import shortenText from './shortenText.js';


describe('Shorten text', () => {
    it('Should keep small text', () => {
        expect(shortenText('something')).toBe('something');
    });

    it('Should shorten long text', () => {
        expect(shortenText({ text: 'Something', length: 5 })).toBe('S ...');
    });

    it('Should shorten html text', () => {
        expect(shortenText({ text: '<div>Som<b>eth</b>ing</div>', length: 5 })).toBe('S ...');
    });

    it('Should shorten text with html special characters', () => {
        expect(shortenText({ text: '<div>S&nbsp;omething</div>', length: 7 })).toBe('S o ...');
    });

    it('Should use proper appendix', () => {
        expect(shortenText({ text: 'Something', length: 5, 'appendix': '.' })).toBe('Some.');
    });
});
