import React, { PropTypes } from 'react';
import { reduxForm }  from 'redux-form';
import _isEqual from 'lodash/isEqual';
import _pick from 'lodash/pick';


export default ({ fields = [], validate = () => {}, initialValues = {} }) => {
    return (WrappedComponent) => {
        const Form = React.createClass({
            propTypes: {
                valid: PropTypes.bool,
                values: PropTypes.object,
                onChange: PropTypes.func,
            },
            getDefaultProps() {
                return {
                    onChange() {},
                };
            },
            componentDidUpdate(prevProps) {
                const { valid, values } = this.props;

                if (_isEqual(prevProps.valid, valid) && _isEqual(prevProps.values, values)) {
                    return;
                }

                if (valid) {
                    this.props.onChange(values);
                }
            },
            render() {
                return (
                    <WrappedComponent
                        {..._pick(this.props, ['fields', 'settings', 'children', 'DataConnectorsPicker'])}
                    />
                );
            },
        });

        return reduxForm({
            form: 'templateSettingsForm',
            fields,
            validate,
            initialValues,
        })(Form);
    };
};
